\ Base64 encoding and decoding
\ Library for DX-Forth
\ Pavel Zampach, 2022
\ *

cr .( Base64 routines loading )

[UNDEFINED] appc [IF]
\ Append char [c] to string [addr u].
code APPC     ( addr u c -- addr u+1 )
       H pop	\ c -> A
     L A mov
       D pop	\ u -> DE
       H pop	\ addr -> HL
       H push
       D dad	\ addr+u -> HL
     A M mov	\ c -> (addr+u)
       D inx	\ u+1 -> DE
       D push
         next
end-code
[THEN]

here 1+
," ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/"
constant TAB
variable PTR
0 value SRC-ADDR
0 value SRC-LEN

: APP=        ( -- )
  [char] = appc
;

: APP-IDX     ( b -- )
  tab + c@ appc
;

: READ        ( -- c )
  src-addr ptr @ 1- + c@
;

: READ-IDX    ( -- b )
  tab 64 read scan
  drop tab -
;

: PTR++       ( -- )
  1 ptr +!
;

\ [flag] is TRUE if can be read from source string
: NEXT?       ( -- flag )
  ptr @ src-len <
  ptr++
;

\ [flag] is TRUE if next char is "="
: NEXT=?      ( -- flag )
  ptr++
  read [char] = =
;

: (PREP)      ( addr u -- )
  ptr off
  to src-len   to src-addr
;

\ ---------- Interface ----------

\ Append to string [addr1 u1] string [addr2 u2] Base64 encoded
: APP-BASE64E ( addr1 u1 addr2 u2 -- addr1 u3 )
  (prep)
  begin
    next?
  while
    read 2 rshift app-idx
    read 3 and 4 lshift
    next? not if
      app-idx app= app=
    end
    read 4 rshift or app-idx
    read $0f and 2 lshift
    next? not if
      app-idx app=
    end
    read 6 rshift or app-idx
    read $3f and app-idx
  repeat
;

\ Append to string [addr1 u1] string [addr2 u2] Base64 decoded
: APP-BASE64D ( addr1 u1 addr2 u2 -- addr1 u3 )
  (prep)
  begin
    next?
  while
    read-idx 2 lshift
    ptr++
    read-idx 4 rshift or appc
    read-idx 4 lshift
    next=? if appc end
    read-idx 2 rshift or appc
    read-idx 6 lshift
    next=? if appc end
    read-idx or appc
  repeat
;

behead tab (prep)
